diff --git a/docs/CHANGELOG b/docs/CHANGELOG
index e1e577ef..dce8412b 100644
--- a/docs/CHANGELOG
+++ b/docs/CHANGELOG
@@ -1,5 +1,7 @@
 10/18/2018 Version 4.3.0 beta2
+    - CVE-2018-17974 heap-buffer-overflow dlt_en10mb_encode (#486)
     - CVE-2018-17582 heap-buffer-overflow in get_next_packet (#484)
+    - CVE-2018-13112 heap-buffer-overflow in get_l2len (#477 dup #408)
 
 01/18/2018 Version 4.3.0 beta1
     - Travis CI build fails due to new build images (#432)
@@ -54,7 +56,7 @@
     - Packet destortion --fuzz-seed option by Gabriel Ganne (#302)
     - Add --unique-ip-loops option to modify IPs every few loops (#296)
     - Netmap startup delay increase (#290)
-    - tcpcapinfo buffer overflow vulnerablily (#278)
+    - CVE-2017-6429 tcpcapinfo buffer overflow vulnerablily (#278)
     - Update git-clone instructions by Kyle McDonald (#277)
     - Allow fractions for --pps option (#270)
     - Print per-loop stats with --stats=0 (#269)
diff --git a/src/common/utils.c b/src/common/utils.c
index 61009974..4e56891f 100644
--- a/src/common/utils.c
+++ b/src/common/utils.c
@@ -123,16 +123,15 @@ _our_safe_free(void *ptr, const char *funcname, const int line, const char *file
 /**
  * get next packet in pcap file
  */
-#define MAX_PCAP_PACKET_LEN (262144) /* this matches Wireshark maximum size */
 u_char *_our_safe_pcap_next(pcap_t *pcap,  struct pcap_pkthdr *pkthdr,
         const char *funcname, const int line, const char *file)
 {
     u_char *pktdata = (u_char *)pcap_next(pcap, pkthdr);
 
     if (pktdata) {
-        if (pkthdr->len > MAX_PCAP_PACKET_LEN) {
+        if (pkthdr->len > MAXPACKET) {
             fprintf(stderr, "safe_pcap_next ERROR: Invalid packet length in %s:%s() line %d: %u is greater than maximum %u\n",
-                    file, funcname, line, pkthdr->len, MAX_PCAP_PACKET_LEN);
+                    file, funcname, line, pkthdr->len, MAXPACKET);
             exit(-1);
         }
 
@@ -156,9 +155,9 @@ int _our_safe_pcap_next_ex(pcap_t *pcap, struct pcap_pkthdr **pkthdr,
     int res = pcap_next_ex(pcap, pkthdr, pktdata);
 
     if (*pktdata && *pkthdr) {
-        if ((*pkthdr)->len > MAX_PCAP_PACKET_LEN) {
+        if ((*pkthdr)->len > MAXPACKET) {
             fprintf(stderr, "safe_pcap_next_ex ERROR: Invalid packet length in %s:%s() line %d: %u is greater than maximum %u\n",
-                    file, funcname, line, (*pkthdr)->len, MAX_PCAP_PACKET_LEN);
+                    file, funcname, line, (*pkthdr)->len, MAXPACKET);
             exit(-1);
         }
 
diff --git a/src/tcpedit/plugins/dlt_en10mb/en10mb.c b/src/tcpedit/plugins/dlt_en10mb/en10mb.c
index 8e08c946..6880727f 100644
--- a/src/tcpedit/plugins/dlt_en10mb/en10mb.c
+++ b/src/tcpedit/plugins/dlt_en10mb/en10mb.c
@@ -483,9 +483,21 @@ dlt_en10mb_encode(tcpeditdlt_t *ctx, u_char *packet, int pktlen, tcpr_dir_t dir)
         return TCPEDIT_ERROR;
     }
 
+    if (pktlen < ctx->l2len) {
+        tcpedit_seterr(ctx->tcpedit,
+                "Unable to process packet #" COUNTER_SPEC " since its new length less then %d L2 bytes.",
+                ctx->tcpedit->runtime.packetnum, ctx->l2len);
+        return TCPEDIT_ERROR;
+    }
+
     /* Make space for our new L2 header */
-    if (newl2len != ctx->l2len)
+    if (newl2len != ctx->l2len) {
+        if (pktlen + (newl2len - ctx->l2len) > MAXPACKET)
+            errx(-1, "New frame too big, new length %d exceeds %d",
+                    pktlen + (newl2len - ctx->l2len), MAXPACKET);
+
         memmove(packet + newl2len, packet + ctx->l2len, pktlen - ctx->l2len);
+    }
 
     /* update the total packet length */
     pktlen += newl2len - ctx->l2len;
